"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.monkeyPatchProcedure = void 0;
const server_1 = require("@trpc/server");
const zod_1 = require("zod");
const procedure_1 = require("../../utils/procedure");
const zod_2 = require("../../utils/zod");
const monkeyPatchProcedure = (procedure) => {
    if (procedure.__MONKEY_PATCHED__)
        return;
    procedure.__MONKEY_PATCHED__ = true;
    const { inputParser } = (0, procedure_1.getInputOutputParsers)(procedure);
    if ((0, zod_2.instanceofZodType)(inputParser)) {
        if ((0, zod_2.instanceofZodTypeLikeVoid)(inputParser)) {
            const zObject = zod_1.z.object({});
            procedure._def.middlewares = procedure._def.middlewares.map((middleware) => {
                if (middleware._type === 'input') {
                    return (0, server_1.createInputMiddleware)(zObject.parseAsync.bind(zObject));
                }
                return middleware;
            });
        }
        // TODO: add out of box support for number/boolean/date etc. (https://github.com/jlalmes/trpc-openapi/issues/44)
    }
};
exports.monkeyPatchProcedure = monkeyPatchProcedure;
//# sourceMappingURL=monkeyPatch.js.map